// crtez2.h - Klasa crtea.

#ifndef _crtez2_h_
#define _crtez2_h_

#include "figura4.h"
#include "niz7.h"
#include <iostream>
#include <utility>
using namespace std;

class Crtez: public Figura {
  Niz<Figura> niz;                                       // Niz figura.
  void pisi(ostream& it) const override { it << niz; }   // Pisanje crtea.
public:
  explicit Crtez(int kap): niz(kap) {}    // Stvaranje praznog crtea.
  Crtez& operator+=(const Figura& f)      // Dodavanje figure kopiranjem.
    { niz += f; return *this;}
  Crtez& operator+=(Figura&& f)           // Dodavanje figure premetanjem.
    { niz += move(f); return *this;}
  Crtez& operator+=(const Vektor& v);     // Pomeranje crtea.
  Crtez* kopija() const& override         // Kopija crtea kopiranjem.
    { return new Crtez(*this); }
  Crtez* kopija() && override             // Kopija crtea premetanjem.
    { return new Crtez(move(*this)); }
};

#endif

