// mnogougao1.h - Klasa mnogouglova u prostoru.

#ifndef _mnogougao1_h_
#define _mnogougao1_h_

#include "figura2.h"
#include "vektor3.h"
#include <iostream>
using namespace std;

class G_indeks {}; // Klasa greaka: Nedozvoljen indeks.
inline ostream& operator<<(ostream& it, const G_indeks&)
  { return it << "*** Nedozvoljen indeks! ***"; }
class Mnogougao: public Figura {
  Vektor* niz;                                  // Temena mnogougla.
  int     n;                                    // Broj temena.
  void pisi(ostream& it) const;                 // Pisanje mnogougla.
  void kopiraj(const Mnogougao& m);             // Kopiranje u mnogougao.
  void premesti(Mnogougao& m)                   // Premetanje u mnogougao.
    { niz = m.niz; n = m.n; m.niz = nullptr; }
  void brisi() { delete [] niz; }               // Oslobaanje memorije.
public:
  explicit Mnogougao(int k=3)                   // Stvaranje mnogougla.
    { niz = new Vektor [n = k]; }
  Mnogougao(const Mnogougao& m) { kopiraj(m); } // Kopirajui konstruktor.
  Mnogougao(Mnogougao&& m) { premesti(m); }     // Premetajui konstruktor.
  ~Mnogougao() { delete [] niz; }               // Unitavanje mnogougla.
  Mnogougao& operator=(const Mnogougao& m) {    // Kopirajua dodela
    if (this != &m) { brisi(); kopiraj(m); }    //   vrednosti.
    return *this;
  }
  Mnogougao& operator=(Mnogougao&& m) {         // Premetajua dodela
    if (this != &m) { brisi(); premesti(m); }   //   vrednosti.
    return *this;
  }
  Mnogougao* kopija() const                     // Kopija mnogougla
    { return new Mnogougao(*this); }
  Mnogougao& operator+=(const Vektor& v);       // Pomeranje mnogougla.
  Vektor teziste() const;                       // Teite.
  Vektor& operator[](int i) {                   // Pristupanje temenu:
    if (i<0 || i>=n) throw G_indeks();          // - promenljivog
    return niz[i];                              //   mnogougla,
  }
  const Vektor& operator[](int i) const {       // - nepromenljivog objekta.
    if (i<0 || i>=n) throw G_indeks();          //   mnogougla.
    return niz[i];
  }
};

#endif

